/* This program reads the state variables and give appropriate calls to 
 *constarint checking method checkConstraints() when
 *the value of the state variables are going to change */
import java.util.*;
import java.io.*;
import java.util.regex.*;

public class MonitorExe4 {
	ArrayList statelist, propertylist;  // contains state variables in the form 'class_name/var_name'
	static int labelno = -2;
	static long millis = 0;  // time to sleep if transition not valid
	static String startState = "";
	
	void getStates(String statefile) { // statefile contains list of state variables one per line
		try {
			System.out.println("Reading file "+statefile);  // Input file stateVars.txt
			statelist = new ArrayList();
			BufferedReader in = new BufferedReader(new FileReader(statefile));
    		String str;
    		while ((str = in.readLine()) != null) {
    			StringTokenizer st = new StringTokenizer(str," ");
    	    	st.nextToken();
    	    	String strvar = st.nextToken();
    	    	//int ind = strvar.lastIndexOf('_');
    	    	//char strch[] = strvar.toCharArray();
    	    	//strch[ind] = '/';
    	    	//str = String.valueOf(strch);
    	    	statelist.add(strvar.trim());
			}
			in.close();     
			}
    catch (IOException e) {
    		}
    }
    
    
    void getProperties() {
    	try {
			System.out.println("Reading file configuration.xml");  // Input file stateVars.txt
			propertylist = new ArrayList();
			BufferedReader in = new BufferedReader(new FileReader("configuration.xml"));
			String REGEX = "<state_properties>.+</state_properties>";
			Pattern pattern = Pattern.compile(REGEX);
			String str;
    		while ((str = in.readLine()) != null) {
		   		Matcher matcher = pattern.matcher(str.trim());
			//StringTokenizer st = new StringTokenizer(str.trim(),"><");
    			if(matcher.find()) {
    			//System.out.println("Entered");
    				StringTokenizer st = new StringTokenizer(str.trim(),"<>");
    				st.nextToken();
    				String properties = st.nextToken();
    				String[] allPropts = properties.split(";");
		   			for(int i=0; i < allPropts.length; i++) {
    					st = new StringTokenizer(allPropts[i].trim()," ");
    					String type = st.nextToken();
    					String property = st.nextToken();
    					propertylist.add(property);
		    		}
    			}
			}
			in.close();     
			//System.out.println(propertylist);
			}
    catch (IOException e) {
    		}
    }

	// This function reads the time to sleep for the program before it checks for the validity of transition
    void getSleepTime() {
    	try {
			System.out.println("Reading file SleepTime.txt");  // Input file stateVars.txt
			BufferedReader in = new BufferedReader(new FileReader("SleepTime.txt"));
    		String str;
    		str = in.readLine();
    		millis = new Long(str).longValue();
			in.close();     
			}
    catch (IOException e) {
    		}
    }
    
 	// This function reads the start state of the program
    void getStartState() {
    	try {
			System.out.println("Reading file FirstState.txt");  // Input file stateVars.txt
			BufferedReader in = new BufferedReader(new FileReader("FirstState.txt"));
    		String str;
    		str = in.readLine();
    		startState = str;
			in.close();     
			}
    catch (IOException e) {
    		}
    }
    
    // This function modifies an assignment to a state variable
    void modifyCode(String pfstr, BufferedWriter out) {  // changes for putfield
    	
    	StringTokenizer st;
    	st = new StringTokenizer(pfstr," ");
    	
    	String ss = st.nextToken().trim();
    	String statevarname = st.nextToken().trim(); // needed for function call
    	System.out.println("In modifyCode statevar = "+statevarname);
    	String type = st.nextToken().trim();
    	System.out.println("In modifyCode statetype = "+type);
 
    	//StringTokenizer strtk = new StringTokenizer(statevarname,"/");
    	//String str1 = strtk.nextToken();
    	//String str2 = strtk.nextToken();
    	//String stVarName = str1+"_"+str2;
    	String stVarName = statevarname.replaceAll("/","_");
    	
    	try {
    		// duplicate the value of state variable on stack for comparison
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");
    	
    		if((type.equals("J")) || (type.equals("D")))
    			out.write("   dup2\r\n");
    		else
    			out.write("   dup\r\n");
    			
    		
    		// convert the value of the variable in a String format
    		if(type.equals("I"))
    			out.write("   invokestatic          java/lang/Integer/toString(I)Ljava/lang/String;\r\n");
    		else if(type.equals("C"))
    			out.write("   invokestatic          java/lang/Character/toString(C)Ljava/lang/String;\r\n");
    		else if(type.equals("J"))
    			out.write("   invokestatic          java/lang/Long/toString(J)Ljava/lang/String;\r\n");
    		else if(type.equals("D"))
    			out.write("   invokestatic          java/lang/Double/toString(D)Ljava/lang/String;\r\n");
    		else if(type.equals("F"))
    			out.write("   invokestatic          java/lang/Float/toString(F)Ljava/lang/String;\r\n");
    		else if(type.equals("S"))
    			out.write("   invokestatic          java/lang/Short/toString(S)Ljava/lang/String;\r\n");
    		else if(type.equals("B"))
    			out.write("   invokestatic          java/lang/Byte/toString(B)Ljava/lang/String;\n");
    		else if(type.equals("Z"))
    			out.write("   invokestatic          java/lang/Boolean/toString(Z)Ljava/lang/String;\r\n");
    	
    	// get the state variable and give the call
    	//Now the StringTokenizer strtk in modifyCode() works for only variables like test/x but 
    	//not for my/test/x and so on to form the stVarName.
    	
    	out.write("   ldc                   \""+stVarName+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");
   
    	out.write("   invokestatic          ChkStSpace/checkTransitionValidity(Ljava/lang/String;Ljava/lang/String;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException not handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// tThe try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write(pfstr+"\r\n");  // if return value 1, valid value
    	
    } catch (IOException e) {
    		}
    }
	
    // This function modifies an assignment to a property variable
    void modifyPropertyCode(String pfstr, BufferedWriter out) {  // changes for putfield
    	
    	StringTokenizer st;
    	st = new StringTokenizer(pfstr," ");
    	
    	String ss = st.nextToken().trim();
    	String statevarname = st.nextToken().trim(); // needed for function call
    	System.out.println("In modifyPropertyCode statevar = "+statevarname);
    	String type = st.nextToken().trim();
    	System.out.println("In modifyPropertyCode statetype = "+type);
 
    	//StringTokenizer strtk = new StringTokenizer(statevarname,"/");
    	//String str1 = strtk.nextToken();
    	//String str2 = strtk.nextToken();
    	//String stVarName = str1+"_"+str2;
    	String stVarName = statevarname.replaceAll("/","_");
    	
    	try {
    		// duplicate the value of state variable on stack for comparison
    		if((type.equals("J")) || (type.equals("D")))
    			out.write("   dup2\r\n");
    		else
    			out.write("   dup\r\n");
    			
    		
    		// convert the value of the variable in a String format
    		if(type.equals("I"))
    			out.write("   invokestatic          java/lang/Integer/toString(I)Ljava/lang/String;\r\n");
    		else if(type.equals("C"))
    			out.write("   invokestatic          java/lang/Character/toString(C)Ljava/lang/String;\r\n");
    		else if(type.equals("J"))
    			out.write("   invokestatic          java/lang/Long/toString(J)Ljava/lang/String;\r\n");
    		else if(type.equals("D"))
    			out.write("   invokestatic          java/lang/Double/toString(D)Ljava/lang/String;\r\n");
    		else if(type.equals("F"))
    			out.write("   invokestatic          java/lang/Float/toString(F)Ljava/lang/String;\r\n");
    		else if(type.equals("S"))
    			out.write("   invokestatic          java/lang/Short/toString(S)Ljava/lang/String;\r\n");
    		else if(type.equals("B"))
    			out.write("   invokestatic          java/lang/Byte/toString(B)Ljava/lang/String;\n");
    		else if(type.equals("Z"))
    			out.write("   invokestatic          java/lang/Boolean/toString(Z)Ljava/lang/String;\r\n");
    	
    	// get the state variable and give the call
    	//Now the StringTokenizer strtk in modifyCode() works for only variables like test/x but 
    	//not for my/test/x and so on to form the stVarName.
    	
    	out.write("   ldc                   \""+stVarName+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");
   
    	out.write("   invokestatic          ChkStSpace/updateStateProperties(Ljava/lang/String;Ljava/lang/String;I)V\r\n");

    	out.write(pfstr+"\r\n");  // if return value 1, valid value
    	
    } catch (IOException e) {
    		}
    }
	
    // This function validates transition for an output statement
	void modifyOutput(String pfstr, BufferedWriter out) {
    	
    	StringTokenizer st;
    	st = new StringTokenizer(pfstr,"(");
    	
    	String ss = st.nextToken().trim();
    	String next = st.nextToken().trim(); // needed for function call
    	//System.out.println("In modifyCode statevar = "+statevarname);
    	st = new StringTokenizer(next,")");
    	String type = st.nextToken().trim();
    	System.out.println("In modifyOutput statetype = "+type);
    	
    	try {
    		
    		// duplicate the output on stack for comparison
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

    		if((type.equals("J")) || (type.equals("D")))
    			out.write("   dup2\r\n");
    		else
    			out.write("   dup\r\n");
    			
    		if(type.equals("I"))
    			out.write("   invokestatic          java/lang/Integer/toString(I)Ljava/lang/String;\r\n");
    		else if(type.equals("C"))
    			out.write("   invokestatic          java/lang/Character/toString(C)Ljava/lang/String;\r\n");
    		else if(type.equals("J"))
    			out.write("   invokestatic          java/lang/Long/toString(J)Ljava/lang/String;\r\n");
    		else if(type.equals("D"))
    			out.write("   invokestatic          java/lang/Double/toString(D)Ljava/lang/String;\r\n");
    		else if(type.equals("F"))
    			out.write("   invokestatic          java/lang/Float/toString(F)Ljava/lang/String;\r\n");
    		else if(type.equals("S"))
    			out.write("   invokestatic          java/lang/Short/toString(S)Ljava/lang/String;\r\n");
    		else if(type.equals("B"))
    			out.write("   invokestatic          java/lang/Byte/toString(B)Ljava/lang/String;\n");
    		else if(type.equals("Z"))
    			out.write("   invokestatic          java/lang/Boolean/toString(Z)Ljava/lang/String;\r\n");
    		else
    			out.write("   invokevirtual         java/lang/Object/toString()Ljava/lang/String;\r\n");

    	
    	out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnOutput(Ljava/lang/String;Ljava/lang/String;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// tThe try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write(pfstr+"\r\n");  // if return value 1, valid value

    } catch (IOException e) {
    		}
    }
		
    // This function validates transition for an executeUpdate function
	void modifyDBOutput(String pfstr, BufferedWriter out) {

    	try {
    		
	    	out.write("   putstatic             IdList/temp Ljava/lang/String;\r\n");
	    	out.write("   putstatic             IdList/s Ljava/sql/Statement;\r\n");
	    	out.write("   getstatic             IdList/s Ljava/sql/Statement;\r\n");
	    	out.write("   getstatic             IdList/temp Ljava/lang/String;\r\n");

    		// duplicate the output on stack for comparison
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

   			out.write("   dup\r\n");
    	
    	out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/s Ljava/sql/Statement;\r\n");

    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnDBOutput(Ljava/lang/String;Ljava/lang/String;Ljava/sql/Statement;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// tThe try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write(pfstr+"\r\n");  // if return value 1, valid value

    } catch (IOException e) {
    		}
    }
		
    // This function validates transition for an input statement
	void modifyInput(String pfstr, BufferedWriter out) {
    	//System.out.println("hello "+pfstr);
    	StringTokenizer st;
    	st = new StringTokenizer(pfstr,")");
    	
    	String ss = st.nextToken().trim();
    	String type = st.nextToken().trim();
    	System.out.println("In modifyInput statetype = "+type);
    	
    	try {
    		
    		// duplicate the input on stack for comparison
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

    		if((type.equals("J")) || (type.equals("D")))
    			out.write("   dup2\r\n");
    		else
    			out.write("   dup\r\n");
    			
    		if(type.equals("I"))
    			out.write("   invokestatic          java/lang/Integer/toString(I)Ljava/lang/String;\r\n");
    		else if(type.equals("C"))
    			out.write("   invokestatic          java/lang/Character/toString(C)Ljava/lang/String;\r\n");
    		else if(type.equals("J"))
    			out.write("   invokestatic          java/lang/Long/toString(J)Ljava/lang/String;\r\n");
    		else if(type.equals("D"))
    			out.write("   invokestatic          java/lang/Double/toString(D)Ljava/lang/String;\r\n");
    		else if(type.equals("F"))
    			out.write("   invokestatic          java/lang/Float/toString(F)Ljava/lang/String;\r\n");
    		else if(type.equals("S"))
    			out.write("   invokestatic          java/lang/Short/toString(S)Ljava/lang/String;\r\n");
    		else if(type.equals("B"))
    			out.write("   invokestatic          java/lang/Byte/toString(B)Ljava/lang/String;\n");
    		else if(type.equals("Z"))
    			out.write("   invokestatic          java/lang/Boolean/toString(Z)Ljava/lang/String;\r\n");
    		else
    			out.write("   invokevirtual         java/lang/Object/toString()Ljava/lang/String;\r\n");

    	
    	//out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnInput(Ljava/lang/String;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// The try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");

    } catch (IOException e) {
    		}
    }
	

    // This function validates transition for an executeQuery 
	void modifyDBInput(String pfstr, BufferedWriter out) {
    	try {
	    	out.write("   dup\r\n");  // duplicate String argument of executeQuery statement , e.g. a select statement
	    	out.write("   putstatic             IdList/dbInput Ljava/lang/String;\r\n");
    		out.write(pfstr+"\r\n");  // executeQuery statement performed
   	    	//out.write("   putstatic             IdList/res Ljava/sql/ResultSet;\r\n");
    	
    	//System.out.println("hello "+pfstr);
    		// get the String input back to the stack
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

   			out.write("   getstatic             IdList/dbInput Ljava/lang/String;\r\n");
    			
    	//out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnInput(Ljava/lang/String;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// The try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");

    } catch (IOException e) {
    		}
    }
	

    // This function validates transition for an Statement/execute() function
	void modifyDBStmt(String pfstr, BufferedWriter out) {
    	try {
	    	out.write("   putstatic             IdList/temp Ljava/lang/String;\r\n");
	    	out.write("   putstatic             IdList/s Ljava/sql/Statement;\r\n");
	    	out.write("   getstatic             IdList/s Ljava/sql/Statement;\r\n");
	    	out.write("   getstatic             IdList/temp Ljava/lang/String;\r\n");

	    	out.write("   getstatic             IdList/selStr Ljava/lang/String;\r\n");

	    	out.write("   iconst_1              \r\n");
	    	out.write("   iconst_0              \r\n");
	    	out.write("   getstatic             IdList/temp Ljava/lang/String;\r\n");
	    	out.write("   invokevirtual         java/lang/String/trim()Ljava/lang/String;\r\n");
	    	out.write("   iconst_0              \r\n");
	    	out.write("   bipush                6\r\n");
	    	out.write("   invokevirtual         java/lang/String/regionMatches(ZILjava/lang/String;II)Z\r\n");

	    	out.write("   ifne                  LABEL"+(labelno+2)+"\r\n");  // current LABEL + 2

	    	out.write("   getstatic             IdList/showStr Ljava/lang/String;\r\n");
	    	out.write("   iconst_1              \r\n");
	    	out.write("   iconst_0              \r\n");
	    	out.write("   getstatic             IdList/temp Ljava/lang/String;\r\n");
	    	out.write("   invokevirtual         java/lang/String/trim()Ljava/lang/String;\r\n");
	    	out.write("   iconst_0              \r\n");
	    	out.write("   iconst_4              \r\n");
	    	out.write("   invokevirtual         java/lang/String/regionMatches(ZILjava/lang/String;II)Z\r\n");

	    	out.write("   ifeq                  LABEL"+(labelno+12)+"\r\n");  // current LABEL + 12

    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

	    	out.write("   dup\r\n");  // duplicate String argument of executeQuery statement , e.g. a select statement
	    	out.write("   putstatic             IdList/dbInput Ljava/lang/String;\r\n");
    		out.write(pfstr+"\r\n");  // executeQuery statement performed
   	    	//out.write("   putstatic             IdList/res Ljava/sql/ResultSet;\r\n");
    	
    	//System.out.println("hello "+pfstr);
    		// get the String input back to the stack
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

   			out.write("   getstatic             IdList/dbInput Ljava/lang/String;\r\n");
    			
    	//out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnInput(Ljava/lang/String;I)I\r\n");

    	out.write("   iconst_1              \r\n");
    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");
    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// The try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");

    	out.write("   goto                  LABEL"+(labelno+10)+"\r\n");  // current LABEL + 10

    		// duplicate the output on stack for comparison
    		labelno+=2;
    		out.write("LABEL"+labelno+":\r\n");

   			out.write("   dup\r\n");
    	
    	out.write("   ldc                   \""+pfstr+"\"\r\n");  // name argument for function call
    	
    	out.write("   getstatic             IdList/s Ljava/sql/Statement;\r\n");

    	out.write("   getstatic             IdList/appId I\r\n");

    	out.write("   invokestatic          ChkStSpace/checkTransitionOnDBOutput(Ljava/lang/String;Ljava/lang/String;Ljava/sql/Statement;I)I\r\n");

    	out.write("   iconst_1              \r\n");

    	out.write("   if_icmpeq             LABEL"+(labelno+6)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 
    	//InterruptedException handled

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write("   ldc2_w                "+millis+"\r\n");

    	out.write("   invokestatic          java/lang/Thread/sleep(J)V\r\n");  // Thread.sleep causes InterruptedException
    	// tThe try catch block is necessary for compilation by javac but not required 
    	// for execution.

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	out.write("   goto                  LABEL"+(labelno-4)+"\r\n");  // current LABEL - 4
    	
    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");
    	
    	out.write(pfstr+"\r\n");  // if return value 1, valid value

    	labelno+=2;
    	out.write("LABEL"+labelno+":\r\n");

    } catch (IOException e) {
    		}
    }
	
	void changeJfiles(String Jfiles[]) {
		for(int k=1;k<Jfiles.length;k++) {  // Checks if all files after stateVars.txt have extension .j
			StringTokenizer strto = new StringTokenizer(Jfiles[k], ".");
			String s = strto.nextToken();
			s = strto.nextToken();
			if(!s.equals("j")) {
				System.out.println("File "+(k+1)+" is not a j file.");
				System.exit(0);
			}
		}
		
		String REGEX = "print\\(|println\\(|write\\(|writeBytes\\(";
		Pattern pattern = Pattern.compile(REGEX);
		
		String REGEX2 = "static main";
		Pattern pattern2 = Pattern.compile(REGEX2);
		
		//String REGEX3 = "read\\(|readLine\\(|readInt\\(|readByte\\(|readChar\\(|readFloat\\(|readBoolean\\(|readDouble\\(";
		String REGEX3 = "readLine\\(";
		Pattern pattern3 = Pattern.compile(REGEX3);

		String REGEX4 = "Statement/executeQuery\\(";
		Pattern pattern4 = Pattern.compile(REGEX4);

		String REGEX5 = "Statement/executeUpdate\\(";
		Pattern pattern5 = Pattern.compile(REGEX5);

		String REGEX6 = "Statement/execute\\(";
		Pattern pattern6 = Pattern.compile(REGEX6);

		Matcher matcher, matcher2, matcher3, exeQrymatcher, exeUpdatematcher, exematcher;
		boolean foundMain = false;

		for(int i=1;i<Jfiles.length;i++) {
			//if(Jfiles[i].extension!=".j")
				// System.exit(0);
		try {
		System.out.println("Reading file "+Jfiles[i]);
		BufferedReader in = new BufferedReader(new FileReader(Jfiles[i]));
		BufferedWriter out = new BufferedWriter(new FileWriter("New"+Jfiles[i]));  // Modified .j file appanded with New in the beginning
    	String str="";
    	String instruction="", type="", statevar="";
    	StringTokenizer st;
    	boolean flag=false, flag2=false;
    	String str2="", statevarname="";
    	String pfstr="";
    	while ((str = in.readLine())!=null) {
    		matcher = pattern.matcher(str.trim());
			matcher2 = pattern2.matcher(str.trim());
			matcher3 = pattern3.matcher(str.trim());
			exeQrymatcher = pattern4.matcher(str.trim());
			exeUpdatematcher = pattern5.matcher(str.trim());
			exematcher = pattern6.matcher(str.trim());

    		if(str.trim().startsWith(".limit stack")) {  // Increase stack length
    			st = new StringTokenizer(str,".limit stack");
    			String s1 = st.nextToken();
    			int n = Integer.parseInt(s1)+ 4;
   				str = "   .limit stack          " + n;
   				out.write(str+"\r\n"); 

   				str = in.readLine();  // .limit locals
   				out.write(str+"\r\n");   		
   				
   				if(foundMain) {  // initialisation routine to be called
    				labelno+=2;
    				out.write("LABEL"+labelno+":\r\n");

			    	out.write("   ldc                   \""+startState+"\"\r\n");  // name argument for function call
   					out.write("   invokestatic          Settings/initialise(Ljava/lang/String;)I\r\n");

			    	out.write("   iconst_1              \r\n");

			    	out.write("   if_icmpeq             LABEL"+(labelno+2)+"\r\n");  // current LABEL + 6. Change 6 to 8 if 

    				out.write("   goto                  LABEL"+(labelno)+"\r\n");  // current LABEL - 4
    	
    				labelno+=2;
    				out.write("LABEL"+labelno+":\r\n");
   					foundMain = false;
   				}
  		
   			}
   			
   			else if(str.trim().startsWith("putfield")){
    			//System.out.println(str);
    			st = new StringTokenizer(str," ");
    				String s = st.nextToken().trim();
    				statevarname = st.nextToken().trim(); 
    				statevarname = statevarname.replaceAll("/","_");
    				System.out.println("variable putfield: "+statevarname); 
    				if(statelist.contains(statevarname)) {
    					pfstr = str;
    					System.out.println("ModifyCode called");
    					modifyCode(pfstr, out);
    				}
    				else if(propertylist.contains(statevarname)) {
    					pfstr = str;
    					System.out.println("ModifyPropertyCode called");
    					modifyPropertyCode(pfstr, out);
    				}
    				else {
    					out.write(str+"\r\n");   		
    				}
   			}
   			
    		else if(str.trim().startsWith("putstatic")){
    			//System.out.println(str);
    			st = new StringTokenizer(str," ");
    				String s = st.nextToken().trim();
    				statevarname = st.nextToken().trim();
    				statevarname = statevarname.replaceAll("/","_");
    				System.out.println("variable putstatic: "+statevarname); 
    				if(statelist.contains(statevarname)) {
    					pfstr = str;
    					System.out.println("ModifyCode called");
    					modifyCode(pfstr, out);
    				}
    				else if(propertylist.contains(statevarname)) {
    					pfstr = str;
    					System.out.println("ModifyPropertyCode called");
    					modifyPropertyCode(pfstr, out);
    				}
    				else {
    					out.write(str+"\r\n");   		
    				}
   			}
   			
    		else if (matcher.find()){  // str contains print( or println( or write(
    			//System.out.println(str);
    			//outstmtlist.add(str);
    			pfstr = str;
    			System.out.println("ModifyOutput called");
    			modifyOutput(pfstr, out);
   			}

    		else if (exeUpdatematcher.find()){  // str contains executeUpdate function
    			pfstr = str;
    			System.out.println("ModifyDBOutput called");
    			modifyDBOutput(pfstr, out);
   			}

    		else if (exeQrymatcher.find()){  // str contains executeQuery function
    			pfstr = str;
    			System.out.println("ModifyDBInput called");
    			modifyDBInput(pfstr, out);
   			}

    		else if (exematcher.find()){  // str contains executeQuery function
    			pfstr = str;
    			System.out.println("ModifyDBStmt called");
    			modifyDBStmt(pfstr, out);
   			}

   			else {
   				out.write(str+"\r\n");   		
   			}

   			if(matcher2.find())
				foundMain = true;
			
			if(matcher3.find())
				modifyInput(str, out);
   			
    	}
    	
    	in.close();
    	out.close();	
		} catch (IOException e) {
    		}
	}
	}
	
	public static void main(String args[]) {
		MonitorExe4 me4 = new MonitorExe4();
		me4.getStartState();
		if(args.length < 2)
			System.out.println("Usage: java MonitorExe4 stateVars.txt <prog1.j> <prog2.j>...");
		me4.getStates(args[0]);
		me4.getProperties();
		me4.getSleepTime();
		me4.changeJfiles(args);
	}
}